use strict;

# Open the ch2_xml_users.csv file for input
open(CSV_FILE, "ch2_xmlusers.csv") || 
  die "Can't open file: $!";

# Open the ch2_xmlusers.xml file for output
open(XML_FILE, ">ch2_xmlusers.xml") || 
  die "Can't open file: $!";

# Print the initial XML header and the root element
print XML_FILE "<?xml version=\"1.0\"?>\n";
print XML_FILE "<users>\n";

# The while loop to traverse through each line in users.csv
while(<CSV_FILE>) {
    chomp;  # Delete the new line char for each line

   # Split each field, on the comma delimiter, into an array
    my @fields = split(/,/, $_);

print XML_FILE<<"EOF";
    <user>
       <first_name>$fields[0]</first_name>
       <last_name>$fields[1]</last_name>
       <email_address>$fields[2]</email_address>
    </user>
EOF
  }

# Close the root element
print XML_FILE "</users>";

# Close all open files
close CSV_FILE;
close XML_FILE;
