use strict;

# Load the XML::Simple module
use XML::Simple;

# Call XML::Simple's new constructor function to create an 
# XML::Simple object and get the reference.
my $simple = XML::Simple->new();

# Read in ch2_xmlusers.xml and return a data structure.  
# Note that forcearray and keeproot are both turned on
my $struct = $simple->XMLin("./ch2_xmlusers.xml", forcearray => 1, keeproot => 1);

# Open ch2_xmlusers.html file for output
# It will create it if it doesn't exist
open(HTML_FILE, ">ch2_xmlusers.html") || 
  die "Can't open file: $!\n";

# Print the initial HTML tags
print HTML_FILE "<html>\n<body>\n";

# The for loop traverses over each user.
# $_ points to the user
for (@{$struct->{users}->[0]->{user}}) {
  # Print the each field in the user structure
print HTML_FILE <<"EOF";
  First Name: $_->{first_name}->[0]<br>
  Last Name: $_->{last_name}->[0]<br>
  Email Address: $_->{email_address}->[0]<br>
  ----------------------------------------<br>
EOF
}

# Print the ending HTML tags
print HTML_FILE "</body><br></html>";

# Close ch2_xmlusers.html
close (HTML_FILE);
