use strict;
use XML::SAX::ParserFactory;

# Set the current package.
$XML::SAX::ParserPackage = "XML::SAX::Expat";

# Instantiate new handler and parser objects.
my $handler = MyHandler->new();
my $parser = XML::SAX::ParserFactory->parser(Handler => $handler);

# Parse the document name that was passed in off the command line.
$parser->parse_uri($ARGV[0]);

package MyHandler;

my $current_element;
my $text;

sub new {
  my $self = shift;
  return bless {}, $self;
}

# start_element handler
sub start_element {
  my ($self, $element) = @_;

  my %atts = %{$element->{Attributes}};
  my $current_element = $element->{Name};
  
  if ($current_element eq "online_order") {
    print "Order Number: $atts{'{}number'}->{Value}\n";
    print "Cut mailing label along perferated marks\n";
    print "-----------------------------------------\n";
    print "Mail To:\n";    
  }
    
}

# characters handler
sub characters {
  my ($self, $character_data) = @_;

  $text = $character_data->{Data};  
}

# end_element handler
sub end_element {
  my ($self, $element) = @_;

  my $current_element = $element->{Name};
  if ($current_element eq "name") {
    print "$text\n";
  }
  elsif ($current_element eq "address") {
    print "$text\n";
    print "-----------------------------------------\n";
  }
  elsif ($current_element eq "phone") {
    print "Phone: $text\n\n";
    print "Please ship the below items:\n";    
  }
  elsif ($current_element eq "item_number") {
    print "\nItem Number: $text\n";
  }
  elsif ($current_element eq "quantity") {
    print "Number of items ordered: $text\n";
  }
  elsif ($current_element eq "item_description") {
    print "Description: $text\n";
  }  
  elsif ($current_element eq "credit_card") {
    print "Credit card (last 4 digits): $text\n";
  }
  elsif ($current_element eq "online_order") {
    print "\n";
  }
}
