use strict;
use XML::Parser::PerlSAX;

# Instantiate a new parser object.
my $saxHandler = SaxHandler->new();
my $parser = XML::Parser::PerlSAX->new(Handler => $saxHandler);
my $inputXmlFile = "ch3_perlsax_catalog.xml";
my %parser_args = (Source => {SystemId => $inputXmlFile});
$parser->parse(%parser_args);

exit;

# Create a new package.
package SaxHandler;
use strict;

my $current_element;

sub new {
  my $type = shift;
  return bless {}, $type;
}

# start_element event handler
sub start_element {
  my ($self, $element) = @_;

  my %atts = %{$element->{Attributes}};
  my $numAtts = keys(%atts);

  # Check to see if this element has attributes.
  if ($numAtts > 0) {
    my ($thisAtt, $key, $val);
    for $key (keys %atts) {
      $val = $atts{$key};

      if ($key eq 'school') {
	print "\nSchool: $val - ";
	}
      elsif ($key eq 'term') {
	print "$val Semester Course Catalog\n\n";
      }
	elsif ($key eq 'name') {
	  print "Class name: $val\n";
	  for (my $i = 0; $i < (12 + length($val)); $i++) {
	    print "-";
	  }
	  print "\n";
	}
    }
  }
  $current_element = $element->{Name};
}

# characters event handler
sub characters {
  my ($self, $character_data) = @_;

  my $text = $character_data->{Data};

  # Remove leading and trailing whitespace.
  $text =~ s/^\s*//;
  $text =~ s/\s*$//;

  if (length($text) ) {
    if (($current_element eq 'description') ) {
      print "Description: $text\n";
    }
    elsif ($current_element eq 'room') {
      print "Room: $text\n";
    }
    elsif ($current_element eq 'day') {
      print "Day: $text\n";
    }
    elsif ($current_element eq 'start_time') {
      print "Start time: $text\n";
    }
    elsif ($current_element eq 'end_time') {
      print "End time: $text\n";
    }
  }
}

# end_element event handler
sub end_element {
  my ($self, $element) = @_;

  if ($element->{Name} eq 'class') {
    print "\n";
  }
}

# start_document event handler
sub start_document {
    my ($self) = @_;
}

# end_document event handler
sub end_document {  
    my ($self) = @_;
}
