use strict;
use XML::DOM;

# Declare a few variables.
my ($packet, %protoCount, $nodeName, @pktInfoArray, $pktInfo);

# Instantiate a new XML::DOM parser.
my $parser = XML::DOM::Parser->new();

# Parse the input XML document.
my $doc = $parser->parsefile ("ch4_dom_netlog.xml");
my $root = $doc->getDocumentElement();

# Retrieve an array of all nodes.
my @packetArray = $root->getChildNodes();

# Loop through the array.
foreach $packet (@packetArray) {
  if ($packet->getNodeType() == ELEMENT_NODE) {
    print "Seqnum: " . $packet->getAttribute("seqnum") . "\n";
    @pktInfoArray = $packet->getChildNodes();

    foreach $pktInfo (@pktInfoArray) {

      if ($pktInfo->getNodeType() == ELEMENT_NODE) {
	$nodeName = $pktInfo->getNodeName();
	$nodeName =~ s/(\w+)/\u\L$1/g;
	
	print "$nodeName";
	
	if ($pktInfo->getNodeName() eq "protocol") {
	  if ($protoCount{$pktInfo->getFirstChild()->getData}) {
	    $protoCount{$pktInfo->getFirstChild()->getData}++;
	  }
	  else {
	    $protoCount{$pktInfo->getFirstChild->getData} = 1;
	  }
	}
	print " : " . $pktInfo->getFirstChild()->getData . "\n";
      }
    }
    print "\n";
  }
}

my ($key);
print "\n----------------------------\n";
print "Protocol Summary\n";
foreach $key (keys %protoCount) {
  print "$key\t$protoCount{$key}\n";
}



