use strict;
use XML::Twig;

# Instantiate the parser object and set the
# subroutine to be called.
my $twig = new XML::Twig(twig_handlers => {product =>\&print_products});
$twig->parsefile( "ch4_twig_retail.xml");

# Handler subroutine
sub print_products {
  my($t, $elt)= @_;

  # Retrieve the element contents here.
  my $name = $elt->first_child('name')->text;
  my $sku = $elt->first_child('sku')->text;
  my $description = $elt->first_child('description')->text;
  my $price = $elt->first_child('price')->text;

  # Print the results here.
  print "------------------------------------\n";
  print "Name = $name\n";
  print "SKU = $sku\n";
  print "Description = $description\n";
  print "Price = $price\n\n";

  # Free the mempory
  $t->purge;
}

