use strict;
use XML::Writer;
use IO::File;

# Open the output XML document.
my $output = new IO::File(">ch5_dbi_config_writer.xml");

# Instantiate a new XML::Writer object.
my $writer = new XML::Writer(OUTPUT => $output, DATA_MODE=>1, 
  			     DATA_INDENT=>4);

# Start generating the XML document.
$writer->xmlDecl("UTF-8");
$writer->doctype("db_config_information", "", "xml-simple.dtd");
$writer->startTag("db_config_information");

$writer->startTag("db_user");
$writer->dataElement("username", "mark");
$writer->dataElement("password", "mark's password");
$writer->endTag("db_user");
 
$writer->startTag("db_server", hostname=>"rocket", os=>"Linux");
$writer->dataElement("server_ip", "192.168.1.10");
$writer->dataElement("db_driver", "MySQL");
$writer->dataElement("port", "3306");
$writer->endTag("db_server");

$writer->startTag("db_server", hostname=>"scooter", os=>"Microsoft Windows");
$writer->dataElement("server_ip", "192.168.1.50");
$writer->dataElement("db_driver", "ODBC");
$writer->dataElement("port", "3379");
$writer->endTag("db_server");

$writer->endTag("db_config_information");

# Destroy the XML::Writer object and close generated XML document.
$writer->end();
$output->close();
