use strict;
use XML::XPath;
use XML::XPath::XMLParser;

my ($nodeset, $protocol, %srcHash, %dstHash, %protocolHash);
my ($thisHost, $key);
my @protocolArray = ("HTTP", "FTP", "SMTP");
my @hostArray = ("bugs", "daffy", "foghorn", "wiley");

# Open the XML document.
my $xp = XML::XPath->new(filename => 'ch8_xpath_network_traffic.xml');

# Loop through our protocol array and try to find a packet
# with the matching protocol type.  If we find a match,
# store it in %protocolHash.
foreach $protocol (@protocolArray) {
  $nodeset = $xp->find("/network_traffic/packet[protocol=\"$protocol\"]");
  $protocolHash{$protocol} = $nodeset->size();
}

# Loop through our host array track find all of the packets
# sent and received by this host.  Store the results in
# %srcHash and %dstHash.
foreach $thisHost (@hostArray) {
  $nodeset = $xp->find("/network_traffic/packet[src=\"$thisHost\"]");
  $srcHash{$thisHost} = $nodeset->size();

  $nodeset = $xp->find("/network_traffic/packet[dst=\"$thisHost\"]");
  $dstHash{$thisHost} = $nodeset->size();
}

# Print the protocol results.
print "Protocol count\n";
print "--------------\n";
foreach $key (sort keys %protocolHash) {
  print "$key, count = $protocolHash{$key}\n";
}

# Print the source host results.
print "\nSource\n";
print "------\n";
foreach $key (sort keys %srcHash) {
  print "$key, count = $srcHash{$key}\n";
}

# Print the dest host results.
print "\nDestination\n";
print "-----------\n";
foreach $key (sort keys %dstHash) {
  print "$key, count = $dstHash{$key}\n";
}



