package Books;
use XML::SAX::ParserFactory;

# This is the method that will be available as a Web service.
sub getInfo {
  shift;  # get the class name
  my $isbn = shift;
  my $return_message = "";

  # Instantiate a new handler object.
  my $handler = Books::Handler->new(ISBN => $isbn, 
                                    RETURN_MESSAGE => \$return_message);
  my $p = XML::SAX::ParserFactory->parser(Handler => $handler);
  $p->parse_uri("books.xml");
  return $return_message;
}

# Handler package definition
package Books::Handler;

my $flag = 0;
my $elem = "";
my $data = "";

sub new {
  my $class = shift;
  die "Usage: new(ISBN => '3429493', RETURN_MESSAGE => \$mess)" if @_ != 4;
  return bless {@_}, $class;  ## This will bless and
                              ## return a Book::Handler class
}

# start_element event handler
sub start_element {
  my ($self, $element) = @_;

  if ($element->{Attributes}->{'{}isbn'}->{Value} eq $self->{ISBN}) {
    $flag = 1;
    $elem = $element->{Name};
  }
}

# characters event handler
sub characters {
  my ($self, $char) = @_;
  $data = $char->{Data};  
}

# end_element event handler
sub end_element {
  my ($self, $element) = @_;

  if ($flag and $element->{Name} eq $elem) {
    $flag = 0;
    $elem = "";
  }

  if ($flag) {
    ${$self->{RETURN_MESSAGE}} .= "$element->{Name}: $data\n";
  }
}

